var table = null;
var vacationKind = null;

function openUserPickerWindow(element) {
    var vWinUsers = window.open('${baseUrl}/secure/popups/UserPickerBrowser.jspa?formName=jiraform&multiSelect=false&element=' + element, 'UserPicker', 'status=yes,resizable=yes,top=100,left=200,width=580,height=750,scrollbars=yes');
    vWinUsers.opener = self;
    vWinUsers.focus();
}

function getSelectedUsers() {
    var users = new Array();
	    table.$('input:checked', {'filter':'applied'}).each(function (id, element) {
	    	var userId = parseInt(element.value);
	    	var row = table.$('tr#'+userId);
	    	var rowId = parseInt(row.attr('row'));
	        users.push({userId: userId, rowId: rowId});
	    });
    return users;
}

function getSelectedEditableUsers() {
	return getSelectedUsers().filter(function(user) {
		return !(vacationKind.type === 'RECURRING' && vacationKind.days[user.rowId].hasDefinition);
	});
}

function bulkSelect(doSelect) {
    table.$('input[name="userCheckbox"]', {'filter':'applied'}).each(function (id, element) {
        element.checked = doSelect;
    });
    updateSelectedButton();
}

function userArrayToString(array) {
    var str = '';
    for (var i = 0; i < array.length; i++) {
        str += array[i].userId;
        if (i < array.length - 1)
            str += ';';
    }
    return str;
}

function updateTableValues() {
    var notApplicableLabel=AJS.I18n.getText('vacationmanager.text.not.applicable');
    var noDayLimitLabel=AJS.I18n.getText('vacationmanager.vacationkind.no.day.limit');

    for (var i = 0; i < vacationKindsData.length; i++) {
        if (vacationKindsData[i].id == AJS.$('#vacationKind').val()) {
            vacationKind = vacationKindsData[i];
        }
    }
    for (i = 0; i < vacationKind.days.length; i++) {
        var daysObj = vacationKind.days[i];
        var row = table.$('tr#'+daysObj.userId);
        if (daysObj.hasDefinition) {
                if (vacationKind.hasDayLimit) {
                    table.cell(row.find('td#availableTime')).data(vmUtils.formatDaysAndTime(daysObj.availableDays, daysObj.availableMinutes));
                }
                else {
                    table.cell(row.find('td#availableTime')).data('<span class="not-applicable-element">' + noDayLimitLabel + '</span>');
                }
                table.cell(row.find('td#usedTime')).data(vmUtils.formatDaysAndTime(daysObj.usedDays, daysObj.usedMinutes));
        } else {
                table.cell(row.find('td#availableTime')).data('<span class="not-applicable-element">'+notApplicableLabel+'</span>');
                table.cell(row.find('td#usedTime')).data('<span class="not-applicable-element">'+notApplicableLabel+'</span>');
        }
        var userCheckbox = AJS.$(row).find('[name=userCheckbox]');
        var detailsBtn = AJS.$(row).find('#detailsButton');
        var addBtn = AJS.$(row).find('#addVacationBtn');
        if (daysObj.hasDefinition) {
            detailsBtn.attr('disabled', false);
        } else {
            detailsBtn.attr('disabled', true);
        }
        if (daysObj.hasDefinition && vacationKind.type=='RECURRING') {
            addBtn.attr('disabled', true);
            userCheckbox.hide();
        } else {
            addBtn.attr('disabled', false);
            userCheckbox.show();
        }
    }

    updateSelectedButton();
}

function updateSelectedButton() {
    var sel=getSelectedEditableUsers().length;
    if (sel > 0) {
        AJS.$('#addToSelected').attr('disabled', false);
        AJS.$('#selectedCount').text('('+sel+')');
    } else {
        AJS.$('#addToSelected').attr('disabled', true);
        AJS.$('#selectedCount').text('');
    }
}

function redirectDetails(userId) {
    AJS.$('<form method="post" class="hidden" action="VacationManager.ManageVacationDefinitions!details.jspa">' +
            '<input name="userIdToAdd" class="hidden" value="' + userId + '"></input>' +
            '<input name="vacationKindId" class="hidden" value="' + vacationKind.id + '"></input>' +
            '</form>').appendTo('body').submit().remove();
}

function redirectAddVacation(userId) {
    AJS.$('<form method="post" class="hidden" action="VacationManager.AddVacationDefinitions!default.jspa">' +
            '<input id="usersToEdit" name="usersToEdit" class="hidden" value="' + userId + '"></input>' +
            '<input name="vacationKind" class="hidden" value="' + vacationKind.id + '"></input>' +
            '</form>').appendTo('body').submit().remove();
}

AJS.$(document).ready(function() {
    AJS.$('[name=user-checkbox]').click(function() {
        AJS.$(this).children()[0].click();
    });

    table=VM$('#vacationDefinitionsTable').DataTable({
        columnDefs: [
            { orderable: false, targets: 0 },
            { orderable: false, targets: -1 }
        ],
        language: datatablesLangObject,
        order: [ [1, 'asc'] ],
        stateSave: true,
        'columns': [
            { 'data': 'checkbox' },
            { 'data': 'fullname' },
            { 'data': 'username' },
            { 'data': 'availableDays', orderable: false },
            { 'data': 'usedTime', orderable: false },
            { 'data': 'actions' }
        ]
    });

    table.$('input[name="userCheckbox"]:checkbox').each(function () {
        AJS.$(this).change(updateSelectedButton);
    });

    table.on( 'search.dt', updateSelectedButton);

    updateTableValues();
    AJS.$('#vacationKind').on('change', function () {
        updateTableValues();
    });

    AJS.$('#addToSelected').click(function () {
        AJS.$('#usersToEdit').val(userArrayToString(getSelectedEditableUsers()));
        AJS.$('#vacationKindId').val(AJS.$('#vacationKind').val());
    });

    AJS.$('input[name="bulkSelect"]').each(function (id, element) {
        AJS.$(this).click(function () {
            bulkSelect(element.checked == true);
        });
    });

    AJS.$('#addToSelected').attr('disabled', true);
    AJS.$('#selectedCount').text('');
} );
