var ManageTeamMembersDialogs = function() {

    function initAddMemberDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamMembersDialogs
                .addMemberDialog());

        AJS.$("[name=addMemberButton]").click(function() {
            var teamId = AJS.$(this).attr("team-id");
            var role = AJS.$(this).attr("role");
            var roleText = AJS.I18n.getText('vacationmanager.action.manage.teams.add.member.role.user');
            if (role == "supervisor") {
                roleText = AJS.I18n.getText('vacationmanager.action.manage.teams.add.member.role.supervisor');
                role = "SUPERVISOR";
            } else {
                role = "USER";
            }
            dialog.getElementByName("userNames").val("");
            dialog.getElementByName("groupNames").val("");
            dialog.getElementByName("role").val(role);
            dialog.getElementByName("roleText").text(roleText);
            dialog.getElementByName("teamId").val(teamId);
            dialog.show();
        });

        dialog.getElementByName("action").change(function() {
            updateTabs(this.value);
        });

        function updateTabs(value) {
            if (value == "add-user") {
                dialog.getElementByName("usersTab").show();
                dialog.getElementByName("groupsTab").hide();
            } else {
                dialog.getElementByName("usersTab").hide();
                dialog.getElementByName("groupsTab").show();
            }
        }

        updateTabs(dialog.getElementByName("action").val());
    }

    function initRemoveUserDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamMembersDialogs
                .removeUserDialog());

        AJS.$("[name=removeUserButton]").click(
                function() {
                    var userName = AJS.$(this).attr("user-name");
                    var teamId = AJS.$(this).attr("team-id");
                    var teamName = AJS.$(this).attr("team-name");
                    var role = AJS.$(this).attr("role");
                    var roleText = AJS.I18n.getText('vacationmanager.action.manage.teams.remove.member.role.user');
                    if (role == "supervisor") {
                        roleText = AJS.I18n.getText('vacationmanager.action.manage.teams.remove.member.role.supervisor');
                        role = "SUPERVISOR";
                    } else {
                        role = "USER";
                    }
                    dialog.getElementByName("teamName").text(teamName);
                    dialog.getElementByName("userName").text(userName);
                    dialog.getElementByName("roleName").text(role);
                    
                    dialog.getElementByName("teamId").val(teamId);
                    dialog.getElementByName("userNames").val(userName);
                    dialog.getElementByName("role").val(role);
                    dialog.show();
                });
    }

    function initRemoveGroupDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamMembersDialogs
                .removeGroupDialog());

        AJS.$("[name=removeGroupButton]").click(
                function() {
                    var groupName = AJS.$(this).attr("group-name");
                    var teamId = AJS.$(this).attr("team-id");
                    var teamName = AJS.$(this).attr("team-name");
                    var role = AJS.$(this).attr("role");
                    var roleText = AJS.I18n.getText('vacationmanager.action.manage.teams.remove.member.role.user');
                    if (role == "supervisor") {
                        roleText = AJS.I18n.getText('vacationmanager.action.manage.teams.remove.member.role.supervisor');
                        role = "SUPERVISOR";
                    } else {
                        role = "USER";
                    }
                    dialog.getElementByName("teamName").text(teamName);
                    dialog.getElementByName("groupName").text(groupName);
                    dialog.getElementByName("roleName").text(role);
                    
                    dialog.getElementByName("teamId").val(teamId);
                    dialog.getElementByName("groupNames").val(groupName);
                    dialog.getElementByName("role").val(role);
                    dialog.show();
                });
    }

    return {
        initAddMemberDialog : initAddMemberDialog,
        initRemoveUserDialog : initRemoveUserDialog,
        initRemoveGroupDialog : initRemoveGroupDialog
    }
}();
