var ManageTeamsDialogs = function() {
    
    function initAddTeamDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamsDialogs.addTeamDialog());

        AJS.$("[name=newTeamButton]").click(function() {
            dialog.getElementByName("name").val("");
            dialog.getElementByName("description").val("");
            dialog.show();
        });
    }

    function initDeleteTeamDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamsDialogs.deleteTeamDialog());

        AJS.$("[name=deleteTeamButton]").click(function() {
            var teamId = AJS.$(this).attr("team-id");
            var teamName = AJS.$(this).attr("team-name");
            dialog.getElementByName("description").html(AJS.I18n.getText('vacationmanager.action.manage.teams.delete.confirmation.text', teamName));
            dialog.getElementByName("teamId").val(teamId);
            dialog.show();
        });

    }
    
    function initEditTeamNameDialog() {
        var dialog = VacmanDialogs.initAndCreateDialog(VacationManager.Templates.Team.ManageTeamsDialogs.editTeamNameDialog());

        AJS.$("[name=editTeamNameButton]").click(function() {
            dialog.getElementByName("name").val(AJS.$(this).attr("team-name"));
            dialog.getElementByName("description").val(AJS.$(this).attr("team-description"));
            dialog.getElementByName("teamId").val(AJS.$(this).attr("team-id"));
            dialog.show();
        });
    }

    return {        
        initAddTeamDialog:initAddTeamDialog,
        initDeleteTeamDialog:initDeleteTeamDialog,
        initEditTeamNameDialog:initEditTeamNameDialog
    }
}();
