AJS.$(document).ready(function() {

    ManageTeamMembersDialogs.initAddMemberDialog();
    ManageTeamMembersDialogs.initRemoveUserDialog();
    ManageTeamMembersDialogs.initRemoveGroupDialog();
    ManageTeamsDialogs.initDeleteTeamDialog();
    ManageTeamsDialogs.initEditTeamNameDialog();

    var supervisorsTable = VM$('#supervisorsTable').DataTable({
        columnDefs: [
           { orderable: false, targets: [-1] }
        ],
        order: [ [0, 'asc'] ],
        language: datatablesLangObject
    });
    
    var usersTable = VM$('#usersTable').DataTable({
        columnDefs: [
            { orderable: false, targets: [0, -1] }
         ],
         order: [ [1, 'asc'] ],
        language: datatablesLangObject
    });
   

    // bulk selection
    function getSelectedUsers() {
        var users = new Array();
        usersTable.$("input:checked", {"filter":"applied"}).each(function (id, element) {
            users.push(element.value);
        });
        return users;
    }
   
    function bulkSelect(doSelect) {
        usersTable.$("input[name='userCheckbox']", {"filter":"applied"}).each(function (id, element) {
            element.checked = doSelect;
        });
        updateSelectedButton();
    }
   
    AJS.$("input[name='bulkSelect']").each(function (id, element) {
        element.addEventListener("click", function () {
            bulkSelect(element.checked == true);
        });
    });
   
    function updateSelectedButton() {
        var sel=getSelectedUsers().length;
        if (sel > 0) {
            AJS.$("#addToSelected").attr("disabled", false);
            AJS.$("[name=selectedCount]").text(AJS.I18n.getText("vacationmanager.action.manage.users.action.bulk.selected.rows", sel));
            setBulkOpeartionButtonsEnabled(true);
        } else {
            AJS.$("#addToSelected").attr("disabled", true);
            AJS.$("[name=selectedCount]").text(AJS.I18n.getText("vacationmanager.action.manage.users.action.bulk.selected.rows", 0));
            setBulkOpeartionButtonsEnabled(false);
        }
    }
    
    function setBulkOpeartionButtonsEnabled(isEnabled) {
        AJS.$("#bulkOperations").attr("aria-disabled", (isEnabled==true)?null:"true");
    }
    
    usersTable.$("[name=user-checkbox]").click(function() {
       AJS.$(this).children()[0].click();
    });
   
   usersTable.$("input[name='userCheckbox']:checkbox").each(function () {
       AJS.$(this).change(updateSelectedButton);
   });
   
   usersTable.on( 'search.dt', updateSelectedButton);
   updateSelectedButton();

    // assign holiday scheme
    var assignHolidaySchemeDialog = VacmanDialogs.initExistingDialog("#assignHolidaySchemeDialog");

    usersTable.$("[name=assignHolidaySchemeButton]").click(function() {
        var userName = AJS.$(this).attr("userName");
        var schemeId = AJS.$(this).attr("schemeId");
        assignHolidaySchemeDialog.getElementByName("usersText").text(userName);
        assignHolidaySchemeDialog.getElementByName("userNames").val(userName);
        assignHolidaySchemeDialog.getElementByName("schemeId").val(schemeId);
        assignHolidaySchemeDialog.show();
    });
    
    AJS.$("[name=bulkAssignHolidaySchemeButton]").click(function () {
        var schemeId = assignHolidaySchemeDialog.getElementByName("schemeId").find("option:first").val();
        assignHolidaySchemeDialog.getElementByName("usersText").text(getSelectedUsers().join(", "));
        assignHolidaySchemeDialog.getElementByName("userNames").val(getSelectedUsers().join(";"));
        assignHolidaySchemeDialog.getElementByName("schemeId").val(schemeId);
        assignHolidaySchemeDialog.show();
    });
    
    assignHolidaySchemeDialog.getForm().submit(function(e) {
        e.preventDefault();
    
        var params = {userNames: assignHolidaySchemeDialog.getElementByName("userNames").val().split(";"),
                schemeId: assignHolidaySchemeDialog.getElementByName("schemeId").val()
        }
    
        jQuery.ajax({
            type : "PUT",
            url : AJS.contextPath() + "/rest/vacation-manager/1.0/vacman-user/holidays/bulk",
            data : JSON.stringify(params),
            dataType : "json",
            contentType: 'application/json; charset=utf-8',
            async : true
        }).done(function(data) {
            var newSchemeName = assignHolidaySchemeDialog.getElementByName("schemeId").find("option[value="+data.schemeId+"]").text();
            
            for (var i=0; i<data.userNames.length; i++) {
                var userName = data.userNames[i];
                var schemeLink = "<a href='VacationManager.ViewHolidayScheme.jspa?schemeId="+data.schemeId+"'>"+newSchemeName+"</a>";
                usersTable.$("tr[user-name="+userName+"]").find("[data-cell-type=holiday-scheme]").html(schemeLink)
            }
        });
    });
    
    // assign workweek scheme
    var assignWorkweekSchemeDialog = VacmanDialogs.initExistingDialog("#assignWorkweekSchemeDialog");

    usersTable.$("[name=assignWorkweekSchemeButton]").click(function() {
        var userName = AJS.$(this).attr("userName");
        var schemeId = AJS.$(this).attr("schemeId");
        assignWorkweekSchemeDialog.getElementByName("usersText").text(userName);
        assignWorkweekSchemeDialog.getElementByName("userNames").val(userName);
        assignWorkweekSchemeDialog.getElementByName("schemeId").val(schemeId);
        assignWorkweekSchemeDialog.show();
    });
    
    AJS.$("[name=bulkAssignWorkweekSchemeButton]").click(function () {
        var schemeId = assignWorkweekSchemeDialog.getElementByName("schemeId").find("option:first").val();
        assignWorkweekSchemeDialog.getElementByName("usersText").text(getSelectedUsers().join(", "));
        assignWorkweekSchemeDialog.getElementByName("userNames").val(getSelectedUsers().join(";"));
        assignWorkweekSchemeDialog.getElementByName("schemeId").val(schemeId);
        assignWorkweekSchemeDialog.show();
    });
    
    assignWorkweekSchemeDialog.getForm().submit(function(e) {
        e.preventDefault();
    
        var params = {userNames: assignWorkweekSchemeDialog.getElementByName("userNames").val().split(";"),
                schemeId: assignWorkweekSchemeDialog.getElementByName("schemeId").val()
        }
    
        jQuery.ajax({
            type : "PUT",
            url : AJS.contextPath() + "/rest/vacation-manager/1.0/vacman-user/workweek/bulk",
            data : JSON.stringify(params),
            dataType : "json",
            contentType: 'application/json; charset=utf-8',
            async : true
        }).done(function(data) {
            var newSchemeName = assignWorkweekSchemeDialog.getElementByName("schemeId").find("option[value="+data.schemeId+"]").text();
            
            for (var i=0; i<data.userNames.length; i++) {
                var userName = data.userNames[i];
                var schemeLink = "<a href='VacationManager.ViewWorkweekScheme.jspa?schemeId="+data.schemeId+"'>"+newSchemeName+"</a>";
                usersTable.$("tr[user-name="+userName+"]").find("[data-cell-type=workweek-scheme]").html(schemeLink)
            }
        });
    });


});
