VM$.configuration = (function() {

    var configurationLoaded = false;
    var configuration = null;
    var pendingCallbacks = new Array();

    AJS.$.ajax({
        type : "GET",
        url : AJS.contextPath() + "/rest/vacation-manager/1.0/configuration",
        contentType : "application/json"
    }).always(function(data) {
        configuration = data;
        configurationLoaded = true;
        for (var cb = 0; cb < pendingCallbacks.length; cb++) {
            var pendingCallback = pendingCallbacks[cb];
            getProperty(pendingCallback.property, pendingCallback.callback);
        }
    });

    function getProperty(property, callback) {
        if (configurationLoaded == false) {
            pendingCallbacks.push({
                property : property,
                callback : callback
            });
        } else {
            callback(configuration[property]);
        }
    }

    function getShowUserPickerVacationWarning(callback) {
        getProperty("showUserPickerWarning", callback);
    }
    
    function getAllowUsersToViewStatistics(callback) {
        getProperty('allowUsersToViewStatistics', callback);
    }

    function getFields(callback) {
        getProperty("fields", callback);
    }

    return {
        getFields: getFields,
        getShowUserPickerVacationWarning : getShowUserPickerVacationWarning,
        getAllowUsersToViewStatistics: getAllowUsersToViewStatistics
    }
})();
