function IssueContainerUtils(container) {

    return {
        getAllPeriodTypeOptions: getAllPeriodTypeOptions,
        getEndDateField: getEndDateField,
        getDailyPeriodOption:getDailyPeriodOption,
        getForm: getForm,
        getHalfDailyDefaultOption: getHalfDailyDefaultOption,
        getHalfDailyPeriodOption: getHalfDailyPeriodOption,
        getHalfOfDayField: getHalfOfDayField,
        getHourlyPeriodOption: getHourlyPeriodOption,
        getIssueTypeField: getIssueTypeField,
        getPeriodTypeDefaultOption: getPeriodTypeDefaultOption,
        getPeriodTypeOptionsContainer: getPeriodTypeOptionsContainer,
        getReporterField: getReporterField,
        getReporterName: getReporterName,
        getStartDateField: getStartDateField,
        getStartTimeField: getStartTimeField,
        getEndTimeMinutesField: getEndTimeMinutesField,
        getUserWorkdayMinutes: getUserWorkdayMinutes,
        getVacationDocumentPeriodType: getVacationDocumentPeriodType,
        getSelectedPeriodType:getSelectedPeriodType,
        geEndTimeMaxMinutes:geEndTimeMaxMinutes
    };

    function getAllPeriodTypeOptions() {
        var periodTypeCfId = container.find('[name=vmPeriodTypeCfId]').val();
        return container.find('input[name=customfield_' + periodTypeCfId + ']');
    }

    function getEndDateField() {
        var endDateCfId = container.find('[name=chart_endDateCfId]').val();
        return container.find('[name="customfield_' + endDateCfId + '"]');
    }
    
    function getDailyPeriodOption() {
        var periodTypeCfId = container.find('[name=vmPeriodTypeCfId]').val();
        var dailyOptionId = container.find('[name=vmPeriodTypeOptionDailyId]').val();
        return container.find('input[name=customfield_' + periodTypeCfId + '][value=' + dailyOptionId + ']');
    }

    function getForm() {
        return container.parents('form').eq(0);
    }

    function getHalfDailyPeriodOption() {
        var periodTypeCfId = container.find('[name=vmPeriodTypeCfId]').val();
        var halfDailyOptionId = container.find('[name=vmPeriodTypeOptionHalfDailyId]').val();
        return container.find('input[name=customfield_' + periodTypeCfId + '][value=' + halfDailyOptionId + ']');
    }

    function getHalfOfDayField() {
        var halfOfDayCfId = container.find('[name=chart_halfDayCfId]').val();
        return container.find('input[type=radio][name=customfield_' + halfOfDayCfId + ']');
    }

    function getHourlyPeriodOption() {
        var periodTypeCfId = container.find('[name=vmPeriodTypeCfId]').val();
        var hourlyOptionId = container.find('[name=vmPeriodTypeOptionHourlyId]').val();
        return container.find('input[name=customfield_' + periodTypeCfId + '][value=' + hourlyOptionId + ']');
    }

    function getIssueTypeField() {
        return container.find('#issuetype-field');
    }

    function getPeriodTypeOptionsContainer() {
        var periodTypeCfId = container.find('[name=vmPeriodTypeCfId]').val();
        return container.find('input[name=customfield_' + periodTypeCfId + ']').parents('fieldset.group');
    }

    function getReporterField() {
        return container.find('#reporter');
    }

	function getReporterName() {
		if (getReporterField().length === 0) {
			return AJS.params.loggedInUser;
		}
		var data = container.find('#reporter').val();
		return Array.isArray(data) ? data[0] : data;
	}

	function getStartDateField() {
        var startDateCfId = container.find('[name=chart_startDateCfId]').val();
        return container.find('[name="customfield_' + startDateCfId + '"]');
    }

	function getStartTimeField() {
		var startDateTimeCfId = container.find('[name=chart_startDateTimeCfId]').val();
		return container.find('[name="customfield_' + startDateTimeCfId + '"]');
	}

	function getEndTimeMinutesField() {
		var endTimeMinutesCfId = container.find('[name=chart_endTimeMinutesCfId]').val();
		return container.find('[name=customfield_' + endTimeMinutesCfId + ']');
	}

    function geEndTimeMaxMinutes() {
        return getEndTimeMinutesField().find('option').last().val();
    }

	function getUserWorkdayMinutes(userName, dateString) {
		return jQuery.ajax({
			type : 'GET',
			url : AJS.contextPath()
					+ '/rest/vacation-manager/1.0/workweek-scheme?userName='
					+ userName + (dateString ? '&date=' +VM$.formatDateIso(dateString) : ''),
			dataType : 'json',
			contentType : 'application/json; charset=utf-8'
		});
	}

	function getVacationDocumentPeriodType() {
		return container.find('input[name=vmVacationDocumentPeriodType]').val();
    }

    function getSelectedPeriodType() {
        var periodTypeCfId = $('[name=vmPeriodTypeCfId]').val();
        var selectedOptionId = $('[name=customfield_' + periodTypeCfId + ']:checked').val();

        var dailyOptionId = $('[name=vmPeriodTypeOptionDailyId]').val();
        var halfDailyOptionId = $('[name=vmPeriodTypeOptionHalfDailyId]').val();
        var hourlyOptionId = $('[name=vmPeriodTypeOptionHourlyId]').val();

        if (selectedOptionId === dailyOptionId) {
            return 'DAILY';
        } else if (selectedOptionId === halfDailyOptionId) {
            return 'HALF_DAILY';
        } else if (selectedOptionId === hourlyOptionId) {
            return 'HOURLY';
        } else {
            throw new Error('Unsupported period type option \'' + selectedOptionId + '\'');
        }
    }

    function getHalfDailyDefaultOption() {
        var halfOfDayCfId = container.find('[name=chart_halfDayCfId]').val();
        return container.find('input[name=customfield_' + halfOfDayCfId + '][value=-1]');
    }

    function getPeriodTypeDefaultOption() {
        var periodTypeCfId = container.find('[name=vmPeriodTypeCfId]').val();
        return container.find('input[name=customfield_' + periodTypeCfId + '][value=-1]');
    }

}
