AJS.$(document).ready(function () {
    var selectedBeforeReload;

    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
        findNewTeamUserPicker();
    });

    JIRA.bind(JIRA.Events.INLINE_EDIT_STARTED, function(e, context, reason) {
        findNewTeamUserPicker();
    });
    
    findNewTeamUserPicker();

    function findNewTeamUserPicker() {
        AJS.$("[name=vm_teamuserpicker]").each(function() {
            var obj = AJS.$(this);
            if (obj.attr("inited") == "false") {
                obj.attr("inited", "true");
                new VacationManagerTeamUserPicker(obj);
            }
        });
    }

    function VacationManagerTeamUserPicker(container) {
        var ajaxCacher = new AjaxCacher(AJS.$);
        var formBody = container.closest(".form-body");
        var fieldGroup = container.closest(".field-group");
        var reporterField = formBody.find("#reporter");
        var fieldId = container.attr("id");
        var selected = container.find("[name=selected]").val();
        var picker = null;

        reporterField.on('change', function() {
            AJS.$.ajax({
                type : "GET",
                url : AJS.contextPath() + "/rest/vacation-manager/1.0/vacman-user/"+reporterField.val()+"/supervisors",
                dataType : "json",
                contentType: 'application/json; charset=utf-8',
                async : true,
                cache : true
            }).done(function(data) {
                populateNewOptions(data.supervisors);
            })
        });

        fieldGroup.find(".vm-team-user-picker-select").each(function(index,value){
            initPicker(AJS.$(value));
        });

        function populateNewOptions(supervisors) {
            selected = container.find("select").val()[0];
            container.empty();
            var pickerRaw = AJS.$(VacationManager.Templates.Team.TeamUserPicker.userPicker({fieldId: fieldId,
                supervisors: supervisors}));
            container.append(pickerRaw);
            initPicker(pickerRaw);
        }

        function initPicker(pickerRaw) {
            picker = new AJS.SingleSelect({
                element: pickerRaw,
                submitInputVal: false,
                showDropdownButton: false,
                removeOnUnSelect: false,
                revertOnInvalid: true,
                width: 500
            });
            pickerRaw.change(function () {
                selectedBeforeReload = pickerRaw.find('option:selected').val();
            });

            if (selectedBeforeReload) {
                selected = selectedBeforeReload;
            } else if (container.find('select').val()) {
                selected = container.find('select').val()[0];
            }

            if (selected) {
                var selectedDescription = container.find('option[value=' + VM$.escapeSelector(selected) + ']').text();
                if (selectedDescription === '') {
                    selected = '';
                }
                picker.setSelection(new AJS.ItemDescriptor({value: selected, label: selectedDescription}));
            }
        }
    }
});